use context::prelude::*;

mod fractal;

use fractal::Fractal;

fn main() -> VerboseResult<()> {
    let context = Context::new()
        .set_vulkan_debug_info(VulkanDebugInfo {
            debugging: true,
            steam_layer: false,
            verbose: false,
            renderdoc: false,
            use_util: false,
        })
        .set_render_core_info(
            VK_FORMAT_R8G8B8_UNORM,
            VK_IMAGE_USAGE_COLOR_ATTACHMENT_BIT,
            true,
        )
        .build()?;

    let fractal = Fractal::new(&context)?;

    context.set_context_object(Some(fractal.clone()))?;
    context.render_core().add_scene(fractal)?;

    context.run()?;

    Ok(())
}
